var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);

var rdTree;
var rdTreeView;

treeView.prototype = {

    invalidate: function() {
        this.treebox.invalidate();
    },

    swap: function(idx1, idx2) {
        if ((idx1 == idx2) || (idx1 < 0) || (idx2 < 0))
            return;

        var temp = this.items[idx1];

        this.items[idx1] = this.items[idx2];
        this.items[idx2] = temp;

        if (this.defaultsignature == idx1) {
            this.defaultsignature = idx2;
        }
        else if (this.defaultsignature == idx2) {
            this.defaultsignature = idx1;
        }
    },

    insertItem: function(newItem) {
        try{
            this.items.push(newItem);
            this.treebox.rowCountChanged(this.rowCount, 1);
        } catch (err) {
            alert(err);
        }
    },

    deleteSelectedItem: function() {
        try {
            var selIdx = this.selection.currentIndex;

            if (selIdx < 0)
                return;

            var newItems = new Array();

            for (var i = 0; i < this.items.length; i++){
                if (i != selIdx)
                    newItems.push(this.items[i]);
            }

            if (selIdx == this.defaultsignature)
                this.defaultsignature = -1;

            this.items = newItems;
            this.treebox.rowCountChanged(selIdx, -1);

            if (newItems.length > 0)
                this.selection.select(selIdx == 0 ? 0 : selIdx - 1);
        } catch (err){
            alert(err);
        }
    },

    getCellText: function(row, column){
        switch (typeof(column) == "object" ? column.id : column){
            case "default":
                return (row == this.defaultsignature ? "Y" : "N");
            case "description":
                return this.items[row].description;
            case "rd":
                return this.items[row].rd;
            default:
                return "";
        }
    },

    setTree: function(treebox){
        this.treebox = treebox;
    },

    cycleCell: function(row, column){
        if ((typeof(column) == "object" ? column.id : column) == "default") {
            if (row == this.defaultsignature){
                this.defaultsignature = -1;
            } else{
                var currDef = this.defaultsignature;
                this.defaultsignature = row;
                this.items[row].isVisible = true;
                this.treebox.invalidateCell(currDef, column);
            }
        }

        // this.treebox.selection.select(row);
        this.selection.select(row);
        this.treebox.invalidateRow(row);
    },

    getImageSrc: function(row, column) {
        if ((typeof(column) == "object" ? column.id : column) == "default") {
            if (row == this.defaultsignature)
                return "chrome://subjects_prefix_switch/skin/default.png";
        }

        return null;
    },

    get rowCount() {
        return this.items.length;
    },

    isContainer: function(row) { return false; },
    isSeparator: function(row) { return false; },
    isSorted: function(row) { return false; },
    cycleHeader: function(col, elem) {},
    getLevel: function(row) { return 0; },
    getRowProperties: function(row, props) {},
    getCellProperties: function(row, col, props) {},
    getColumnProperties: function(colid, col, props) {}
};

function treeView(items, defaultsignature){
    this.items = items;
    this.defaultsignature = defaultsignature;
    this.treebox = null;
}

function optionsOnLoad(){
    var elementID;
    var element;
    var eltType;
    var defpref;

    for (var i = 0; i < CONFIGURATION_IDS.length; i++){
        elementID = CONFIGURATION_IDS[i];
        element = document.getElementById(elementID);

        if  (!element) break;

        eltType = element.localName;
        str.data = element.getAttribute("defaultpref");

        if  (eltType == "radiogroup"){
            try {
                element.selectedItem = element.childNodes[rdi_prefs.getIntPref(element.getAttribute("prefstring"))];
            } catch (e) {
                element.selectedItem = element.childNodes[element.getAttribute("defaultpref")];
                try{
                    rdi_prefs.setIntPref(element.getAttribute("prefstring"), element.getAttribute("defaultpref") );
                }catch (e) {}
            }
        } else if (eltType == "checkbox") {
            try {
                element.checked = (rdi_prefs.getBoolPref(element.getAttribute("prefstring")));
            } catch(e){
                defpref = element.getAttribute("defaultpref");
                element.checked = (defpref == "true");
                try {
                    rdi_prefs.setBoolPref(element.getAttribute("prefstring"), (defpref == "true"));
                } catch (e) {}
            }
        } else if (eltType == "textbox") {
            try {
                element.setAttribute("value", rdi_prefs.getComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString).data);
            } catch (e) {
                element.setAttribute("value", element.getAttribute("defaultpref"));
                try {
                    rdi_prefs.setComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString, str);
                } catch (e) {}
            }
        } else if (eltType == "menulist") {
            try {
                element.insertItemAt(0, rdi_prefs.getComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString).data);
                element.selectedIndex = 0;
            } catch (e) {
                element.insertItemAt(0, element.getAttribute("defaultpref"));
                element.selectedIndex = 0;
                try {
                    rdi_prefs.setComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString, str);
                } catch (e) {}
            }
        } else if (eltType == "listbox") {
            try {
                fillListboxFromArray(element, 
                    rdi_prefs.getComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString).data.split(";"));
            } catch (e) {
                fillListboxFromArray(element, element.getAttribute("defaultpref").split(";"));
                try {
                    rdi_prefs.setComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString, str);
                } catch (e) {}
            }
        }
    }

    initTree();

    if (window && window.arguments && window.arguments[0])
        document.documentElement.acceptDialog();
}

function initTree() {
    var treeData = loadTreeData();
    var defaultRD = -1;

    try {
        defaultRD = parseInt(rdi_prefs.getCharPref("defaultrd"));
    } catch(e) {}

    rdTree = document.getElementById("subjects_prefix_switchTree");
    rdTreeView = new treeView(treeData, defaultRD);
    rdTree.view = rdTreeView;
    rdTreeView.invalidate();
    onSelectItem();
}

function loadTreeData() {
    var dataString;
    var items = new Array();

    try {
        dataString = rdi_prefs.getComplexValue("rds", Components.interfaces.nsISupportsString).data;

        if (dataString != "") {
            if (dataString.indexOf(getRDEntrySplitSign()) < 0) {
                dataString = upgradeSettings(dataString);
            }
            var itemStrings = dataString.split(getRDPrefEntriesSplitSign());
            var itemData;

            for (var i = 0; i < itemStrings.length; i ++) {
                itemData = itemStrings[i].split(getRDEntrySplitSign());

                items.push(new createItem(itemData[0], itemData[1]));
            }
        }
    } catch (e) {
        alert(e);
    }
  
    return items;
}

function upgradeSettings(dataString) {
    var r1 = new RegExp(/\*/g);
    var r2 = new RegExp(/\|/g);

    return dataString.replace(r1, getRDEntrySplitSign()).replace(r2, getRDPrefEntriesSplitSign());
}

function onDialogAccept() {
    var elementID;
    var element;
    var eltType;

    for (var i = 0; i < CONFIGURATION_IDS.length; i++) {
        elementID = CONFIGURATION_IDS[i];
        element = document.getElementById(elementID);

        if  (!element) break;

        eltType = element.localName;

        if  (eltType == "radiogroup")
            rdi_prefs.setIntPref(element.getAttribute("prefstring"), parseInt(element.value));
        else if  (eltType == "checkbox")
            rdi_prefs.setBoolPref(element.getAttribute("prefstring"), element.checked);
        else if (eltType == "textbox" && element.preftype == "int")
            rdi_prefs.setIntPref(element.getAttribute("prefstring"), parseInt(element.getAttribute("value")));
        else if (eltType == "textbox") {
            str.data = element.value;
            rdi_prefs.setComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString, str);
        } else if (eltType == "menulist") {
            str.data = element.selectedItem.label;
            rdi_prefs.setComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString, str);
        } else if (eltType == "listbox") {
            str.data = getArrayFromListbox(element);
            rdi_prefs.setComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString, str);
        }
    }

    saveTreeData();
}

function saveTreeData() {
    var dataString = "";
    var rowCount = rdTreeView.rowCount;

    for (var i = 0; i < rowCount ; i++) {
        if (dataString == "") {
            dataString =
                rdTreeView.getCellText(i, "description")    + getRDEntrySplitSign() + rdTreeView.getCellText(i, "rd");
        } else {
            dataString =    dataString + getRDPrefEntriesSplitSign() +
                rdTreeView.getCellText(i, "description")    + getRDEntrySplitSign() + rdTreeView.getCellText(i, "rd");
        }
    }

    str.data = dataString;
    rdi_prefs.setComplexValue("rds", Components.interfaces.nsISupportsString, str);
    rdi_prefs.setCharPref("defaultrd", rdTreeView.defaultsignature);
}

function onDialogCancel(){
}

function onSelectItem() {
    var selIdx = rdTreeView.selection.currentIndex;
    var rowCount = rdTreeView.rowCount;

    document.getElementById("up").disabled = selIdx <= 0;
    document.getElementById("down").disabled = selIdx < 0 || selIdx >= rowCount - 1;
    document.getElementById("delete").disabled = selIdx < 0;
    document.getElementById("edit").disabled = selIdx < 0;

    return true;
}

function newItem() {
    var item = new createItem("", "");

    window.openDialog("chrome://subjects_prefix_switch/content/setrd.xul",
        "_blank", "chrome,centerscreen,modal,resizable=yes,dependent=yes", item);
        
    if (item.path != "" && item.description != "") {
        rdTreeView.insertItem(item);
        rdTreeView.invalidate();
    }
}

function editItem() {
    var selIdx = rdTreeView.selection.currentIndex;
    if (selIdx < 0)
        return;

    window.openDialog("chrome://subjects_prefix_switch/content/setrd.xul",
        "_blank", "chrome,centerscreen,modal,resizable=yes,dependent=yes", rdTreeView.items[selIdx]);

    rdTreeView.invalidate();
}

function deleteItem() {
    rdTreeView.deleteSelectedItem();
    rdTree.focus();
}

function moveItem(moveUp) {
    var fromIdx = rdTreeView.selection.currentIndex;
    var toIdx;

    rdTree.focus();

    if (moveUp) {
        if (fromIdx <= 0)
            return;

        toIdx = fromIdx - 1;
    } else {
        if (fromIdx >= rdTreeView.rowCount - 1)
            return;

        toIdx = fromIdx + 1;
    }

    rdTreeView.swap(fromIdx, toIdx);
    rdTreeView.invalidate();
    rdTreeView.selection.select(toIdx);
    rdTreeView.treebox.ensureRowIsVisible(toIdx);
}

function onExportPressed() {
    return pickFile(getLocalizedMessage("options.pickExportTitle"),
                    Components.interfaces.nsIFilePicker.modeSave,
                    "subswitch.csv",
                    function(file) {
                        try {
                            var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
                                 createInstance(Components.interfaces.nsIFileOutputStream);

                            // use 0x02 | 0x10 to open file for appending.
                            foStream.init(file, 0x02 | 0x08 | 0x20, 0666, 0);
                            // write, create, truncate
                            // In a c file operation, we have no need to set file mode with or operation,
                            // directly using "r" or "w" usually.

                            // if you are sure there will never ever be any non-ascii text in data you can
                            // also call foStream.writeData directly
                            var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].
                                                      createInstance(Components.interfaces.nsIConverterOutputStream);
                            converter.init(foStream, "UTF-8", 0, 0);

                            converter.writeString("Description;Prefix;isDefault\n");
                            for (var i = 0; i < rdTreeView.rowCount ; i++) {
                                let defaultPref = (rdTreeView.defaultsignature == i) ? "yes" : "no";

                                converter.writeString(rdTreeView.getCellText(i, "description")
                                    + ";" + rdTreeView.getCellText(i, "rd")
                                    + ";"+defaultPref+"\n");
                            }
                            converter.close(); // this closes foStream
                            foStream.close();
                            
                            showMessage(getLocalizedMessage("options.pickExportTitle"),
                                            getLocalizedMessage("options.pickExportSuccess"));
                        } catch (e) {
                            showMessage(getLocalizedMessage("options.pickExportTitle"),
                                            getLocalizedMessage("options.pickExportError")+e);
                        }

                    }
       );
}

function onImportPressed() {
    return pickFile(getLocalizedMessage("options.pickImportTitle"),
                     Components.interfaces.nsIFilePicker.modeOpen,
                     "subswitch.csv",
                    function(file) {
                        try {
                            var fiStream = Components.classes["@mozilla.org/network/file-input-stream;1"].
                                createInstance(Components.interfaces.nsIFileInputStream);

                            fiStream.init(file, -1, -1, 0);

                            var converter = Components.classes["@mozilla.org/intl/converter-input-stream;1"]
                                .createInstance(Components.interfaces.nsIConverterInputStream);

                            converter.init(fiStream, "UTF-8", 1024, 0xFFFD);
                            converter.QueryInterface(Components.interfaces.nsIUnicharLineInputStream);

                            if (converter instanceof Components.interfaces.nsIUnicharLineInputStream) {
                                var line = {};
                                var cont;
                                do {
                                    cont = converter.readLine(line);
                                    if (line.value != "Description;Prefix;isDefault") {
                                        var splitted = line.value.split(";");
                                        if (splitted.length != 3)
                                            throw new Error(getLocalizedMessage("options.pickImportInvalidFormat"));
                                        var item = new createItem(splitted[0], splitted[1]);
                                        if (item.path != "" && item.description != "") {
                                            rdTreeView.insertItem(item);
                                            if (splitted[2] == "yes") {
                                                rdTreeView.defaultsignature = rdTreeView.rowCount - 1;
                                            }
                                        }
                                    }
                                // Now you can do something with line.value
                                } while (cont);
                                rdTreeView.invalidate();

                               converter.close();
                               fiStream.close();

                               showMessage(getLocalizedMessage("options.pickImportTitle"),
                                            getLocalizedMessage("options.pickImportSuccess"));

                            } else {
                                throw new Error(getLocalizedMessage("options.pickImportInvalidOperation"));
                            }
                        } catch (e) {
                            showMessage(getLocalizedMessage("options.pickImportTitle"),
                                            getLocalizedMessage("options.pickImportError")+e);
                        }
                    }
       );
}

function pickFile(localizedTitle, fileMode, fileName, func) {
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
    fp.init(window, localizedTitle, fileMode);
    //  fp.appendFilters(Components.interfaces.nsIFilePicker.filterAll);
    var dirService = Components.classes["@mozilla.org/file/directory_service;1"].
                  getService(Components.interfaces.nsIProperties);
    var homeDirFile = dirService.get("Home", Components.interfaces.nsIFile); // returns an nsIFile object
   
    fp.defaultString = fileName;
//    fp.displayDirectory = homeDirFile;
    
    fp.appendFilter("CSV", "*.csv");
    var res = fp.show();

    if (res == Components.interfaces.nsIFilePicker.returnOK) {
        var file = fp.file; // file is nsIFile, data is a string
        func(fp.file);
    }
    
    return true;
}

function addAutoSwitch(type) {
    var input = document.getElementById("address");
    var listbox = document.getElementById("discoveryIgnoreList");

    var msgInvalid = getLocalizedMessage("options.invalidAddress");
    var msgDuplicate = getLocalizedMessage("options.duplicateAddress");

    if (!validateAutoswitch(input.value, type)) {
        alert(msgInvalid);
        return;
    }

    for (var i = 0; i < listbox.getRowCount(); i++) {
        if (listbox.getItemAtIndex(i).value == input.value) {
            alert(msgDuplicate);
            return;
        }
    }

    listbox.appendItem(input.value, input.value);
    listbox.ensureIndexIsVisible(listbox.getRowCount()-1);
    input.value = "";
}

function removeAutoswitch(type) {
    var listbox = document.getElementById("discoveryIgnoreList");
    var selected = listbox.selectedIndex;

    if (selected >= 0)
        listbox.removeItemAt(selected);
}

function validateAutoswitch(input, type) {
    if (input.indexOf("?") > -1) {
        if (input.charAt(0) == "?")
            input = "X" + input;

        if (input.charAt(input.length - 2) == "." &&
             input.charAt(input.length - 1) == "?" )
            input += "X";

        input = input.split("?").join("X");
        dumpStr(input);
    }

    var validate = new RegExp(rx);

    return validate.test(input);
}

