function getItem() {
    var arg = window.arguments[0];
    var item;
    if (arg instanceof Ci.nsIDialogParamBlock) {
        item = new createItem(arg.GetString(21), arg.GetString(20));
    } else {
        item = arg;
    }

    return item;
}

function setRDOnLoad() {
    var item = getItem();

    if (item) {
        document.getElementById("rd").value = item.rd;
        document.getElementById("description").value = item.description;
    }
}

function setRDOnDialogAccept() {
    var isValid = false;

    try {
        isValid = checkDescription() && checkRD();

        if (isValid) {
            var arg = window.arguments[0];
            if (arg instanceof Ci.nsIDialogParamBlock) {
                arg.SetInt(0, 0);
                arg.SetString(21, document.getElementById("description").value);
                arg.SetString(20, document.getElementById("rd").value);
             } else {
                var item = arg;
                if (item) {
                    item.description = document.getElementById("description").value;
                    item.rd = document.getElementById("rd").value;
                }
            }
        }
    } catch (err) {
        alert(err);
    }
    return isValid;
}

function onDialogCancel()
{
}

function checkDescription() {
    var description = document.getElementById("description");
    var isValid = checkElem(description);

    if (!isValid) {
        alert(getLocalizedMessage("setRD.invalidDescription"));
        description.focus();
    }

    return isValid;
}

function checkRD() {
    var rd = document.getElementById("rd");
    var isValid = checkElem(rd);

    if (!isValid) {
        alert(getLocalizedMessage("setRD.invalidPath"));
        rd.focus();
    }

    return isValid;
}

function checkElem(elem) {
    var isValid;
    
    if (elem == null || elem.value == "" 
        || elem.value.indexOf("*") > -1
        || elem.value.indexOf("|") > -1) {
        isValid = false;
    } else {
        isValid = true;
    }
    
    return isValid;
}
