Cu.import("resource://app/modules/gloda/mimemsg.js");
Cu.import("resource://app/modules/gloda/connotent.js");

var rdi_loadStatus = false;
var rdi_initStatus = false;

var rdi_currRD = null;
var rdi_currRDLabel = null;
var rdi_isRD = false;

var loadRDfromEmail = true;
var addRDtoEmail = true;

var rdi_main = {

     init : function() {
        if (rdi_initStatus)
            return;

        var defaultRD;
        var offbydefault, contextmenu;
        var initdelay;

        try {
            defaultRD = parseInt(rdi_prefs.getCharPref("defaultrd"));
            offbydefault = rdi_prefs.getBoolPref("offbydefault");
            contextmenu = rdi_prefs.getBoolPref("contextmenu");
            loadRDfromEmail = rdi_prefs.getBoolPref("loadRDfromEmail");
            addRDtoEmail = rdi_prefs.getBoolPref("addRDtoEmail");
        } catch (e) {
            dumpStr('rdi_main.init-> '+e);
            defaultRD = -1;
            offbydefault = false;
            contextmenu = true;
            initdelay = 1000;
        }

        var ctxmenu = document.getElementById("subjects_prefix_switchContext");
        ctxmenu.setAttribute("hidden", !contextmenu);

        if ((defaultRD > -1) || offbydefault) {
           setTimeout("rdi_main.delayedInit(" + defaultRD + ", " + offbydefault + ")", initdelay);
        }

        rdi_initStatus = true;
    },

    subjects_prefix_switch : function() {
        var subjectElement = GetMsgSubjectElement();
        
        subjectElement.editor.beginTransaction();
         
        if (!rdi_isRD && rdi_currRD != null) {
            rdi_main.insertRD(subjectElement, rdi_currRD, rdi_currRDLabel);
        } else {
            if (rdi_main.searchRD(subjectElement)) {
                rdi_main.removeRD(subjectElement);
		    }
        }

        SetComposeWindowTitle();
        subjectElement.editor.endTransaction();
    },

    searchRD : function(subjectElement) {
        var indexOf = subjectElement.value.indexOf(rdi_currRD);
        return (indexOf > -1);
    },

    removeRD : function(subjectElement) {
        var start = subjectElement.value.indexOf(rdi_currRD);
        var len = rdi_currRD.length
        
        subjectElement.value = 
            // 0 - RD
            subjectElement.value.substring(0, start) 
            // RD - koniec z usuniecie spacji po RD
            + (subjectElement.value.substring(start+len).charAt(0) == ' '
                ? subjectElement.value.substring(start + len + 1)
                : subjectElement.value.substring(start + len));
        
        rdi_isRD = false;
    },

    insertRD : function(subjectElement, rd, rdLabel) {
        subjectElement.editor.beginningOfDocument();
        subjectElement.value = rd + ' ' + subjectElement.value;
        
        rdi_currRD = rd;
        rdi_currRDLabel = rdLabel;
        rdi_isRD = true;

        dumpStr('insertRD->' + rd + ' ' +rdLabel);
    },

    loadRD : function(idx, del) {
        var rd = rdi_main.loadRDProperty(1)[idx];
        var rdLabel = rdi_main.loadRDProperty(0)[idx];

        var subjectElement = GetMsgSubjectElement();
        var currentEditor = subjectElement.editor;
        var initialRange = currentEditor.selection.getRangeAt(0).cloneRange();
        var hasRD = rdi_main.searchRD(subjectElement);
        currentEditor.beginTransaction();

        if (hasRD && del) {
            rdi_main.removeRD(subjectElement);
        }
        rdi_main.insertRD(subjectElement, rd, rdLabel);
        
        SetComposeWindowTitle();
        currentEditor.endTransaction();

        currentEditor.selection.removeAllRanges();
        currentEditor.selection.addRange(initialRange);

        rdi_main.sanitize();
    },

    sanitize : function()  {
        rdi_initStatus = false;
    },

    onLoad : function() {
        if (rdi_loadStatus)
            return;

        rdi_main.ensurePrefs();
        rdi_main.init();
        
        rdi_loadStatus = true;
    },

    ensurePrefs : function() {
        for (var i = 0; i < CONFIGURATION_IDS.length; i++) {
            if (rdi_prefs.getPrefType(CONFIGURATION_IDS[i]) == rdi_prefs.PREF_INVALID)  {
                openOptions(true);
                return;
             }
        }
    },

    delayedInit : function(defaultRD, offbydefault) {
        var hasDefaultRD = defaultRD > -1;
        if (hasDefaultRD) {
            rdi_currRD = rdi_main.loadRDProperty(1)[defaultRD];
            rdi_currRDLabel = rdi_main.loadRDProperty(0)[defaultRD];
			if (!offbydefault) {
			   rdi_main.loadRD(defaultRD, rdi_initStatus);
			}
        }
        if(loadRDfromEmail) {
            rdi_main.loadOriginalMsgSSHeader();
        }
    },

    initMenuPopup : function(element) {
        var menuPopup = document.getElementById("subjects_prefix_switchMenuPopup-" + element);

        rdi_main.removeMenuItems(menuPopup);

        if (element != "toolbar") {
            rdi_main.insertOnOffItem(menuPopup, getLocalizedMessage("menuItem.onOff"), getLocalizedMessage("toolTip.onOff"));
            menuPopup.appendChild(document.createElement("menuseparator"));
        }

        var descriptionData = rdi_main.loadRDProperty(0);
        var rdData = rdi_main.loadRDProperty(1);

        for (var i = 0; i < descriptionData.length; i++) {
            rdi_main.insertMenuItem(menuPopup, descriptionData[i], rdData[i], i);
        }

        if (descriptionData.length > 0) {
            menuPopup.appendChild(document.createElement("menuseparator"));
        }
        
        rdi_main.insertOptionsItem(menuPopup, getLocalizedMessage("menuItem.options"), getLocalizedMessage("toolTip.enterOptions"));
    },

    loadRDProperty : function(idx) {
        var dataString;
        var items = new Array();

        try {
            dataString = rdi_prefs.getComplexValue("rds", Ci.nsISupportsString).data;

            if (dataString != "") {
                var itemStrings = dataString.split(getRDPrefEntriesSplitSign());
                var itemData;

                for (var i = 0; i < itemStrings.length; i ++) {
                    itemData = itemStrings[i].split(getRDEntrySplitSign());
                    items.push((itemData[idx]) ? itemData[idx] : "");
                }
            }
        }
        catch (e) {}

        return items;
    },

    addRDProperty : function(rd, rdLabel) {
         dumpStr('-> addRDProperty; rd = ' + rd + '; rdLabel = ' + rdLabel);
         try {
            let dataString = rdi_prefs.getComplexValue("rds", Ci.nsISupportsString).data;
            let newEntry =  rdLabel + getRDEntrySplitSign() + rd;

            if (dataString != "") {
                dataString += getRDPrefEntriesSplitSign() + newEntry;
            } else {
                dataString = newEntry;
            }

            var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
            str.data = dataString;
            rdi_prefs.setComplexValue("rds", Components.interfaces.nsISupportsString, str);
         } catch (e) {
             dumpStr('-> addRDProperty; ' + e);
         }
    },

    removeMenuItems : function(menu) {
        var children = menu.childNodes;

        for (var i = children.length - 1; i >= 0; i--) {
            menu.removeChild(children[i]);
        }
    },

    insertMenuItem : function(menu, label, tooltip, idx) {
        var item = rdi_main.createItem("subjects_prefix_switch_RD_" + idx, label, tooltip, "rdi_main.loadRD(" + idx + ", true); event.stopPropagation();");
		menu.appendChild(item);
    },

    insertOptionsItem : function(menu, label, tooltip) {
        var item = rdi_main.createItem("subjects_prefix_switch_openOptions", label, tooltip, "openOptions(false); event.stopPropagation();");
		menu.appendChild(item);
    },

    insertOnOffItem : function(menu, label, tooltip) {
        var item = rdi_main.createItem("subjects_prefix_switch_onOff", label, tooltip, "rdi_main.subjects_prefix_switch(); event.stopPropagation();");
		menu.appendChild(item);
    },

	createItem : function(id, label, tooltip, oncommand) {
        var item = document.createElement("menuitem");

        item.setAttribute("id", id);
        item.setAttribute("label", label);
        item.setAttribute("tooltiptext", tooltip);
        item.setAttribute("oncommand", oncommand);
        item.setAttribute("disabled", false);

        return item;
	},

    loadOriginalMsgSSHeader : function() {
        let messenger = Cc["@mozilla.org/messenger;1"].createInstance(Ci.nsIMessenger);
        let msgURI = gMsgCompose.originalMsgURI;
        dumpStr('loadOriginalMsgSSHeader; originalMsgURI->'+msgURI);
        if (msgURI) {
            let msgHdr = messenger.messageServiceFromURI(msgURI).messageURIToMsgHdr(msgURI);

            if (!rdi_main.isAddressOnIgnoreList(msgHdr.author)) {
                try {
                    MsgHdrToMimeMessage(msgHdr, null, function(aMsgHdr, aMimeMsg) {
                        if (aMimeMsg == null) /* shouldn't happen, but sometimes does? */
                            return;

                        if (rdi_main.parseSubSwitchMimeHeader(aMimeMsg)) {
                            rdi_main.subjects_prefix_switch();
                        }

                    });
                } catch (e if e.result == Cr.NS_ERROR_FAILURE) {
                    // Offline messages generate exceptions, which is unfortunate.  When
                    // that's fixed, this code should adapt. XXX
                    dumpStr('loadOrgMsg; no ssHeader ->');
                }
            }
        }
    },

    isAddressOnIgnoreList : function(author) {
        var result = false;
        dumpStr(author);
        var ignoreList = rdi_prefs.
                getComplexValue("discoveryIgnoreList", Components.interfaces.nsISupportsString).data.split(";");

        if (author.charAt(0) == "\"" && author.charAt(author.length - 1) == "\"")
            author = author.substring(1, author.length - 1);
        if (author.indexOf(">") > -1) {
            let authorStripRegEx = new RegExp("(" + rx_user + "\@" + rx_domain + ")");
            let m = authorStripRegEx.exec(author);
            if (m != null) {
                author = m[0];
            }
        }
        dumpStr(author);
        
        if (ignoreList.length > 0) {
            var validate = new RegExp(rx);
            var match;
            if (validate.test(author)) {
                for (var j = 0; j < ignoreList.length; j++) {
                    if (ignoreList[j].indexOf("?") > -1) {
                        let ignoreTriggerRegEx = new RegExp(ignoreList[j].split("?").join(rx_wildcard));
                        dumpStr(">>>"+ignoreList[j].split("?").join(rx_wildcard));
                        match = ignoreTriggerRegEx.test(author);
                    } else {
                        match = (autoSwitchTrigger[k].toLowerCase() == author.toLowerCase());
                    }

                    if (match) {
                        result = true;
                        break;
                    }
                }
            }
        }

        return result;
    },

    parseSubSwitchMimeHeader : function(aMimeMsg) {
        let ssKey, ssDesctiption;
        let ssHeader = aMimeMsg.get(SUBSWITCH_MIME_HEADER);
        dumpStr('parseSubSwitchMimeHeader; ssHeader ->'+ssHeader);
        var result = false;
        var found = false;

        if (ssHeader) {
            let ssStrings = ssHeader.split(';');
            ssDesctiption = ssStrings[0].trim();
            ssKey = ssStrings[1].trim();
            dumpStr('parseSubSwitchMimeHeader; ssDesctiption ->'+ssDesctiption+' ssKey ->'+ssKey);
        } else {
            let discoveryPattern = rdi_prefs.getCharPref("discoveryItemPattern");
            let subject = aMimeMsg.get("Subject");
            let re = new RegExp(discoveryPattern);
            let m = re.exec(subject);
            if (m != null) {
                ssKey = m[0];
                ssDesctiption = m[0];
            }
        }
        
        if (ssKey != null) {
            let remoteSP = rdi_main.removeIgnoredSigns(ssKey);
            dumpStr('loadOriginalMsgSSHeader; dopasowanie prefiksu remoteSP ->'+remoteSP);

            let rdData = rdi_main.loadRDProperty(1);
            
            for (var i = 0; i < rdData.length; i++) {
               let userSP = rdi_main.removeIgnoredSigns(rdData[i]);
               dumpStr('loadOriginalMsgSSHeader; dopasowanie prefiksu ->'+rdData[i]+' '+userSP);
               if (remoteSP.toLowerCase() == userSP.toLowerCase()) {
                  dumpStr('loadOriginalMsgSSHeader; znaleziono prefiks ->'+rdData[i]);
                  dumpStr('loadOriginalMsgSSHeader; znaleziono prefiks userSP ->'+userSP);
 //TODO: ustawianie biezacego 
                  found = true;
                  break;
               }
            }
            if (!found) {
                let args = [ssKey, ssDesctiption];
                if (rdi_main.displayConfirm(args)) {
                    rdi_main.addRDProperty(args[0], args[1]);
                    result = true;
                }
            }
        }
        
        return (result || found);
    },

    displayConfirm : function (args) {
        var strbundle = document.getElementById("subjects_prefix_switch.locale");

        var title = strbundle.getString("discovery.confirmTitle");
        var msg = strbundle.getFormattedString("discovery.confirmMessage", args);
        var header = strbundle.getString("discovery.confirmHeader");
        var params = Cc["@mozilla.org/embedcomp/dialogparam;1"].createInstance(Ci.nsIDialogParamBlock);
        params.SetNumberStrings(30);
        
        params.SetString(0, msg);
        params.SetString(2, "question-icon");
        params.SetString(3, header);
        params.SetString(12, title);
        
        params.SetString(20, args[0]);
        params.SetString(21, args[1]);

        window.openDialog("chrome://subjects_prefix_switch/content/prefix_found.xul", null,
            "chrome,centerscreen,modal,dialog,resizable=no", params);

        args[0] = params.GetString(20);
        args[1] = params.GetString(21);
            
        return params.GetInt(0) == 0 ? true : false;
    },

    removeIgnoredSigns : function (prefix) {
        let result = prefix;
        let ignoreSigns = rdi_prefs.getCharPref("discoveryIgnoreSigns");
        for (var i = 0; i < ignoreSigns.length; i++) {
            result = result.replace(ignoreSigns.charAt(i), '');
        }
        return result;
    },

    onSend : function() {
        dumpStr('-> onSend; addRDtoEmail = '+addRDtoEmail);
        if (addRDtoEmail) {
            try {
                gMsgCompose.compFields.otherRandomHeaders += SUBSWITCH_MIME_HEADER + ": " + rdi_currRDLabel + "; " + rdi_currRD +" \r\n";
                dumpStr(gMsgCompose.compFields.otherRandomHeaders);
            } catch (ex) {
                dumpStr ("ERROR: Cannot add current RD to message\n" + ex + "\r\n");
            }
        }
        dumpStr('<- onSend');
    }
};

window.addEventListener("compose-send-message", rdi_main.onSend, true)
window.addEventListener("load", rdi_main.onLoad, true);
window.addEventListener("compose-window-close", rdi_main.sanitize, true);
window.addEventListener("compose-window-reopen", rdi_main.init, true);
